#include <stdio.h>
#include <ctype.h>

char *nextWord(char *text, int *L) {
    // η μεταβλητή (στατική) που θυμάται που είχαμε βρει την προηγούμενη λέξη (την αρχή της)
    static char *prevWord = NULL;

    // εάν δε δοθεί νέο κείμενο
    if (text == NULL) {
        // και δεν υπάρχει και προηγούμενη λέξη
        if (prevWord == NULL) {
            // τότε τίποτα δε βρέθηκε...
            if (L != NULL)
                *L = 0;
            return NULL;
        }
        // αλλιώς συνεχίζουμε από την προηγούμενη λέξη
        text = prevWord;
        // ψάχνοντας μέχρι το τέλος του κειμένου
        while (*text != 0) {
            // τον πρώτο χαρακτήρα που δεν είναι γράμμα (δηλαδή χαρακτήρας λέξης)
            if (!isalpha(*text)) {
                // μόλις τον βρούμε σταματάμε την αναζήτηση
                break;
            }
            // προχωράμε στον επόμενο χαρακτήρα
            text++;
        }
        // σε αυτό το σημείο έχουμε "βγει" από τη λέξη, είτε επειδή είναι το
        // τέλος του κειμένου, είτε επειδή βρήκαμε χαρακτήρα μη αλφαβητικό
    }

    // εάν μας έχει δοθεί pointer σε μεταβλητή που θα βάλουμε το μήκος
    if (L != NULL) {
        // τότε τη μηδενίζουμε αρχικά
        *L = 0;
    }

    // για κάθε χαρακτήρα του κειμένου από αυτό το σημείο και πέρα
    while (*text != 0) {
        // εάν είναι αλφαβητικός ξεκινά μια νέα λέξη
        if (isalpha(*text)) {
            // αποθηκεύουμε το σημείο που βρέθηκε η λέξη
            // (επειδή το text το αλλάζουμε κατά τον υπολογισμό του μήκους)
            prevWord = text;
            // εάν μας ζητήθηκε να υπολογίσουμε και το μήκος της
            if (L != NULL) {
                // για κάθε αλφαβητιό χαρακτήρα μέχρι το τέλος του κειμένου
                while (*text != 0 && isalpha(*text)) {
                    // αυξάνουμε το μέχρι στιγμής μήκος που βρέθηκε
                    (*L)++;
                    // προχωράμε στον επόμενο χαρακτήρα
                    text++;
                }
            }
            // επιστρέφουμε την αρχή της λέξης
            return prevWord;
        }
        // προχωράμε στον επόμενο χαρακτήρα
        text++;
    }

    // για να έφτασε εδώ ο κώδικας δε βρέθηκε κάποια λέξη,
    // οπότε δεν υπάρχει λέξη να θυμόμαστε ως "προηγούμενη"
    prevWord = NULL;
    // και επιστρέφουμε το NULL ως ένδειξη ότι δε βρέθηκε κάτι
    return NULL;
    // ΣΗΜΕΙΩΣΤΕ ότι σε αυτό το σημείο το *L είναι 0 ήδη από πιο
    //           πάνω
}

int main(void) {
    char *someText = "San bgeis ston phgaimo, gia thn Ithaki...";
    //                ^0   ^5   ^10  ^15  ^20  ^25  ^30  ^35  ^40
    char *nullText = NULL;

    // ως υπόδειγμα για το πως τυπώνει η printf το NULL
    printf("%s\n", nullText);

    // το μήκος της λέξης που θα βρεθεί
    int Length = 0;

    // βρες 1η φορά τη λέξη
    char *next = nextWord(someText, &Length);
    // εμφάνισέ τη μαζί με το μήκος της
    printf("%s (%d)\n", next, Length);
    // για κάθε επόμενη (εφόσον βρεθεί)
    while ((next = nextWord(NULL, &Length)) != NULL) {
        // εμφάνισε τη μαζί με το μήκος της
        printf("%s (%d)\n", next, Length);
    }

    return 0;
}

// Άλλος τρόπος, πιο "συμπαγής" αλλά κάπως πιο "αργός" στην εκτέλεση κατά μέσο όρο στη γενική περίπτωση
/*
char *nextWord(char *text, int *L) {
    static char *afterPrevWord = NULL;
    char *result = NULL;

    if (L != NULL) {
        *L = 0;
    }

    if (text == NULL) {
        if (afterPrevWord != NULL) {
            text = afterPrevWord;
        } else {
            return NULL;
        }
    }

    while (*text) {
        if (isalpha(*text)) {
            result = text;
            break;
        }
        text++;
    }
    if (result == NULL) {
        return NULL;
    }

    while(*text && isalpha(*text)) {
        if (L != NULL) (*L)++;
        text++;
    }
    afterPrevWord = text;

    return result;
}
*/